// CMFCDlg.h : header file
//

#if !defined(AFX_CMFCDLG_H__9B8EDB9B_4133_4931_B435_5A737354276B__INCLUDED_)
#define AFX_CMFCDLG_H__9B8EDB9B_4133_4931_B435_5A737354276B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\TestUtils\TestUtils.h"

/////////////////////////////////////////////////////////////////////////////
// CCMFCDlg dialog

class CCMFCDlg : public CDialog
{
// Construction
public:
	void MehodCallClick(int iInitVal);
	void VirtualMehodCallClick(int iInitVal);
	double FloatTest(int iInitVal);

	CCMFCDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CCMFCDlg)
	enum { IDD = IDD_CMFC_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCMFCDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CCMFCDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void pbMemberAccess_Click();
	afx_msg void pbMethodCall_Click();
	afx_msg void pbSortQuick_Click();
	afx_msg void pbSortBubble_Click();
	afx_msg void pbComputPi_Click();
	afx_msg void pbTreeTest_Click();
	afx_msg void VirtualMehodCall_Click();
	afx_msg void pbStringTest_Click();
	afx_msg void pbFloatTest_Click();
	afx_msg void pbStrAtrFloatTest_Click();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
protected:
	enum SORT_TYPE { stQuickSort, stBubbleSort, stTreeSort, stInsertSort1, stInsertSort2 };
	void SortTest(LPCTSTR szFileName, SORT_TYPE SortType, const int ciByts, int iIterationsCnt);
	double StrangeAttractr(long iInitVal);
	CComPtr<IUtility> m_spIUtility;
public:
	afx_msg void OnBnClickedHeaptest2();
	afx_msg void OnBnClickedpbsortinsert();
	afx_msg void OnBnClickedpbsortinsert2();
};

class CTest1
{
public:
	CTest1() : m_i(0) {}

	int m_i;
	int __fastcall GetInt();
	void __fastcall Inc();
	void __fastcall Test(int i, double d, short sh, LPTSTR sz);
	virtual void __fastcall TestVirtual(int i, double d, short sh, LPTSTR sz);
	void __fastcall Add(int i);
};
class CTest2 : public CTest1
{
public:
	virtual void __fastcall TestVirtual(int i, double d, short sh, LPTSTR sz);
};

extern HANDLE g_hNeap;

#define REPLACE_NEW_DELETE()

//#define REPLACE_NEW_DELETE() \
//inline void* __cdecl operator new(size_t n) \
//{ \
//	return HeapAlloc(g_hNeap, 0, n); \
//} \
// \
//inline void __cdecl operator delete(void* p) \
//{ \
//	HeapFree(g_hNeap, 0, p); \
//}

//#define REPLACE_NEW_DELETE() \
//inline void* __cdecl operator new(size_t n) \
//{ \
//	if(!g_hNeap) \
//		g_hNeap = HeapCreate(HEAP_NO_SERIALIZE, 10000000 * 40, 0); \
//	return HeapAlloc(g_hNeap, HEAP_NO_SERIALIZE, n); \
//} \
// \
//inline void __cdecl operator delete(void* p) \
//{ \
//	if(!g_hNeap) \
//	{ \
//		HeapDestroy(g_hNeap); \
//		g_hNeap = NULL; \
//	} \
//	/*HeapFree(g_hNeap, HEAP_NO_SERIALIZE, p);*/ \
//}
//

//#define REPLACE_NEW_DELETE() \
//inline void* __cdecl operator new(size_t n) \
//{ \
//	return GlobalAlloc(GMEM_FIXED, n); \
//} \
// \
//inline void __cdecl operator delete(void* p) \
//{ \
//	GlobalFree(p); \
//}

//#define _QUICK_HEAP_FOR_OBJ_
#define _QUICK_HEAP_AUTO_

#include "QuickHeap.h"

#ifdef _QUICK_HEAP_AUTO_
__declspec(selectany) QuickHeap g_QuickHeap;
#endif //_QUICK_HEAP_AUTO_

class CBase
{
public:
#ifdef _QUICK_HEAP_FOR_OBJ_
	static QuickHeapPool gQuickHeapPoolEqualZero;
	static QuickHeapPool gQuickHeapPoolLessZero;
	static QuickHeapPool gQuickHeapPoolGreatZero;
	inline void * __cdecl CBase::operator new(size_t n);
	inline void __cdecl CBase::operator delete(void* p);
#endif //_QUICK_HEAP_FOR_OBJ_
#ifdef _QUICK_HEAP_AUTO_
	inline void * __cdecl CBase::operator new(size_t n);
	inline void __cdecl CBase::operator delete(void* p);
#endif //_QUICK_HEAP_AUTO_
	inline CBase(const int i) : m_pGreat(NULL), m_pLess(NULL), m_pEqual(NULL), m_i(i) {}
	inline ~CBase()
	{
		delete m_pGreat;
		delete m_pLess;
		delete m_pEqual;
	}
	int m_i;
	CBase * m_pGreat;
	CBase * m_pLess;
	CBase * m_pEqual;
};

class CTestGreatZero : public CBase
{
public:

	inline CTestGreatZero(const int i) : CBase(i), m_i1(0), m_i2(0), m_i3(0) {}
protected:
	int m_i1;
	int m_i2;
	int m_i3;
};

class CTestLessZero : public CTestGreatZero
{
public:
	inline CTestLessZero(const int i) : CTestGreatZero(i), m_i4(0), m_i5(0) {}
	int m_i4;
	int m_i5;
};


class CTestEqualZero : public CTestLessZero
{
public:
	inline CTestEqualZero(const int i) : CTestLessZero(i), m_i6(0), m_d(0) {}
private:
	int m_i6;
	double m_d;
};

#ifdef _QUICK_HEAP_FOR_OBJ_
inline void * __cdecl CBase::operator new(size_t n)
{
	switch(n)
	{
	case sizeof(CTestEqualZero): return gQuickHeapPoolEqualZero.Alloc();
	case sizeof(CTestLessZero):	 return gQuickHeapPoolLessZero.Alloc();
	case sizeof(CTestGreatZero): return gQuickHeapPoolGreatZero.Alloc();
	default: ATLASSERT(0);   return NULL;
	}
}
inline void __cdecl CBase::operator delete(void* p)
{
	QHBlock * pBlock = (QHBlock*)p;
	pBlock--;
	QuickHeapPool * pQuickHeapPool = (QuickHeapPool*)pBlock->m_pQuickHeapPool;
	pQuickHeapPool->FreeBlock(pBlock);
}
#endif //_QUICK_HEAP_FOR_OBJ_
#ifdef _QUICK_HEAP_AUTO_
inline void * __cdecl CBase::operator new(size_t n){ return g_QuickHeap.Alloc(n); }
inline void __cdecl CBase::operator delete(void* p){ return g_QuickHeap.Free(p); }
#endif //_QUICK_HEAP_AUTO_

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.


#endif // !defined(AFX_CMFCDLG_H__9B8EDB9B_4133_4931_B435_5A737354276B__INCLUDED_)
