//---------------------------------------------------------------------------

//#define _RWSTD_COMPILE_INSTANTIATE 

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include <atl\atlimpl.cpp>
#include "..\TestUtils\TestUtils_i.c"
#include <string>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
int CTest1::GetInt()
{
	return m_i;
}
void CTest1::Inc()
{
	//m_i++;
	m_i = m_i + 1;
}
void CTest1::Add(int i)
{
	m_i += i;
}

void CTest1::Test(int i, double d, short sh, LPTSTR sz)
{
	i, d, sh, sz;
}

void __fastcall CTest1::TestVirtual(int i, double d, short sh, LPTSTR sz)
{
	i, d, sh, sz;
}

void __fastcall CTest2::TestVirtual(int i, double d, short sh, LPTSTR sz)
{
	i, d, sh, sz;
}

template <class SType> void BubbleSort(SType *item, int left, int right)
{
	int i, j;
	SType x;
	
	for(i = left + 1; i <= right; i++)
		for(j = right; j >= i; j--)
			if(item[j - 1] > item[j])
			{
				x  = item[j];
				item[j] = item[j - 1];
				item[j - 1] = x;
			}
}
class CTestGreatZero : public CBase
{
public:
	REPLACE_NEW_DELETE()
	inline CTestGreatZero(const int i) : CBase(i), m_i1(0), m_i2(0), m_i3(0) {}
protected:
	int m_i1;
	int m_i2;
	int m_i3;
};

class CTestLessZero : public CTestGreatZero
{
public:
	REPLACE_NEW_DELETE()
	inline CTestLessZero(const int i) : CTestGreatZero(i), m_i4(0), m_i5(0) {}
	int m_i4;
	int m_i5;
};

class CTestEqualZero : public CTestLessZero
{
public:
	REPLACE_NEW_DELETE()
	inline CTestEqualZero(const int i) : CTestLessZero(i), m_i6(0), m_d(0) {}
private:
	int m_i6;
	double m_d;
};


template <class SType> void __fastcall QuickSort(SType *item, int left, int right)
{
	int i, j;
	SType center;
	SType x;
	i = left;
	j = right;
	center = item[(left + right) / 2];
	while(i <= j)
	{
		while (item[i] < center && i < right)
			i++;
		while (item[j] > center && j > left)
			j--;
		
		if (i<=j){
			x  = item[i];
			item[i] = item[j];
			item[j] = x;
			i++;
			j--;
		}
	}
	if(left < j)
		QuickSort(item, left, j);
	if(right > i)
		QuickSort(item, i, right);
}

void AddNode(CBase * pRoot, const CBase * pNew)
{
	if(pNew->m_i > pRoot->m_i)
	{
		if(pRoot->m_pGreat)
			AddNode(pRoot->m_pGreat, pNew);
		else
			pRoot->m_pGreat = (CBase *)pNew;
	}
	else if(pNew->m_i < pRoot->m_i)
	{
		if(pRoot->m_pLess)
			AddNode(pRoot->m_pLess, pNew);
		else
			pRoot->m_pLess = (CBase *)pNew;
	}
	else
	{
		if(pRoot->m_pEqual)
			AddNode(pRoot->m_pEqual, pNew);
		else
			pRoot->m_pEqual = (CBase *)pNew;
	}
}

void TreeSort(int *item, int left, int right)
{
	CTestEqualZero Root(0);
	CBase * pNewNode;
	for(int i = left; i <= right; i++)
	{
		const int iCurrItem = item[i];
		if(iCurrItem < 0)
			pNewNode = new CTestLessZero(iCurrItem);
		else if(iCurrItem == 0)
			pNewNode = new CTestEqualZero(iCurrItem);
		else
			pNewNode = new CTestGreatZero(iCurrItem);
		AddNode(&Root, pNewNode);
	}
}

BOOL pi(LPTSTR szPi, const int digits)
{
	LPTSTR szCurDigit = szPi;
	if (digits > 54900)
	{
		::MessageBox(::GetActiveWindow(), _T("n must be <= 54900"), _T("Error in pi()"), 0);
		return FALSE;
	}
	
	int d = 0, e, b, g, r;
	int c = (digits / 4 + 1) * 14;
	int * a = (int*)alloca(c * sizeof(int));
	int f = 10000;
	
	for(int i = 0; i < c; i++)
		a[i] = 20000000;
	
	while((b = c -= 14) > 0)
	{
		d = e = d % f;
		
		while(--b > 0)
		{
			d = d * b + a[b];
			g = (b << 1) - 1;
			a[b] = (d % g) * f;
			d /= g;
		}

		r = e + d / f;

		if (r < 1000)
		{
			if(r > 99)
			{
				*szCurDigit = '0';
				szCurDigit++;
			}
			else if(r > 9)
			{
				*szCurDigit = '0';
				szCurDigit++;
				*szCurDigit = '0';
				szCurDigit++;
			}
			else
			{
				*szCurDigit = '0';
				szCurDigit++;
				*szCurDigit = '0';
				szCurDigit++;
				*szCurDigit = '0';
				szCurDigit++;
			}
			//pi.Append(zero[r > 99 ? 0 : r > 9 ? 1 : 2]);
		}
		itoa(r, szCurDigit, 10);
		szCurDigit = szCurDigit + lstrlen(szCurDigit);
		//pi.Append(r);
	}
	*szCurDigit = 0;
	return TRUE;
}

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
    CoInitialize(NULL);
    /*HRESULT hr = */CoCreateInstance(CLSID_Utility, NULL, CLSCTX_ALL, IID_IUtility, (void**)&m_spIUtility);
    //ATLASSERT(hr == S_OK);
}
__fastcall TForm1::~TForm1()
{
        m_spIUtility.Release();
        CoUninitialize();
}




//---------------------------------------------------------------------------

const int c_iCount = 1000000000;
//Member Access
void __fastcall TForm1::Button1Click(TObject *Sender)
{
        CTest1 test1 = CTest1();
	m_spIUtility->TimerStart();
	for(int i = 0; i < c_iCount; i++)
	{
		test1.Inc();
	}
	m_spIUtility->TimerEnd(/*sbsInfo*/);
	test1;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::MethodCallClick(TObject *Sender)
{
        MehodCallClick(c_iCount);
}
//---------------------------------------------------------------------------




void TForm1::MehodCallClick(int iInitVal)
{
	CTest1 test1;
	m_spIUtility->TimerStart();
	for(int i = 0; i < iInitVal; i++)
	{
		test1.Test(i, 3.123, 1, _T("Some string"));
	}
	m_spIUtility->TimerEnd(/*sbsInfo*/);
}

void __fastcall TForm1::VirtualMehodClick(TObject *Sender)
{
    VirtualMehodCallClick(c_iCount);
}

void TForm1::VirtualMehodCallClick(int iInitVal)
{
	CTest2 test2;
	CTest1 & test1 = test2;
	m_spIUtility->TimerStart();
	for(int i = 0; i < iInitVal; i++)
	{
		test1.TestVirtual(i, 3.123, 1, _T("Some string"));
	}
	m_spIUtility->TimerEnd(/*sbsInfo*/);
}


//---------------------------------------------------------------------------

void __fastcall TForm1::SortQuickClick(TObject *Sender)
{
    SortTest(_T("..\\q3.ZIP"), stQuickSort, 100000000, 1);
}


void TForm1::SortTest(LPCTSTR szFileName, SORT_TYPE SortType, const int ciByts, int iIterationsCnt)
{
	const int ciElemCnt = ciByts / sizeof(int);
	HANDLE hInputFile = CreateFile(szFileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL, NULL);
	if(hInputFile == INVALID_HANDLE_VALUE)
	{
		TCHAR szMsg[1000];
		wsprintf(szMsg, _T("Cannot open \"%s\" file!"), szFileName);
		MessageBox(NULL, szMsg, _T("Sort Test Error!"), 0);

		return;
	}
	int * iAryData = new int[ciElemCnt];
	int * iAryWork = new int[ciElemCnt];
	DWORD dwNumberOfBytesRead ;
	ReadFile(hInputFile, iAryData, ciByts, &dwNumberOfBytesRead, NULL);
	ATLASSERT((int)dwNumberOfBytesRead == ciByts);

	memcpy(iAryWork, iAryData, ciByts);
	MessageBox(NULL, _T("Go?!"), _T("Sort Test."), 0);
	int i;
	m_spIUtility->TimerStart();
	switch(SortType)
	{
	case stQuickSort:
		for(i = 0; i < iIterationsCnt; i++)
		{
			if(i > 0)
				memcpy(iAryWork, iAryData, ciByts);
			QuickSort(iAryWork, 0, ciElemCnt - 1);
		}
		break;
	case stBubbleSort:
		for(i = 0; i < iIterationsCnt; i++)
		{
			if(i > 0)
				memcpy(iAryWork, iAryData, ciByts);
			BubbleSort(iAryWork, 0, ciElemCnt - 1);
		}
		break;
	case stTreeSort:
		for(i = 0; i < iIterationsCnt; i++)
		{
			if(i > 0)
				memcpy(iAryWork, iAryData, ciByts);
//		g_hNeap = HeapCreate(0, 0, 0);
			TreeSort(iAryWork, 0, ciElemCnt - 1);
//		HeapDestroy(g_hNeap);
//		g_hNeap = NULL;
		}
		break;
	}
	m_spIUtility->TimerEnd(/*sbsInfo*/);
	CloseHandle(hInputFile);
	delete[] iAryData;
	delete[] iAryWork;
}

//---------------------------------------------------------------------------

void __fastcall TForm1::SortBubbleClick(TObject *Sender)
{
    SortTest(_T("..\\q3.ZIP"), stBubbleSort, 150000, 1);    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComputPiClick(TObject *Sender)
{
	const int iDigit = 15000;
	m_spIUtility->TimerStart();
	TCHAR szPi[iDigit + 1];
	pi(szPi, iDigit);
	m_spIUtility->TimerEnd();
	TCHAR szMsg[iDigit + 100];
	wsprintf(szMsg, _T("The %d of Pi is "), iDigit);
	lstrcat(szMsg, szPi);
	MessageBox(NULL, szMsg, _T("Pi Test"), 0);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::TreeTestClick(TObject *Sender)
{
    SortTest(_T("..\\q3.ZIP"), stTreeSort, 10000000, 1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::StringTestClick(TObject *Sender)
{
	m_spIUtility->TimerStart();
	String ss;
	for(int i = 0; i < 10000000; i++)
	{
		ss = _T(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>");
		ss += _T(" ");
		ss += _T(" ");
		ss += _T("");
		ss += '\n';
	}
	m_spIUtility->TimerEnd();
 }
//---------------------------------------------------------------------------
//FloatTest
void __fastcall TForm1::Button9Click(TObject *Sender)
{
	FloatTest(1000000000);
}

double TForm1::FloatTest(int iInitVal)
{
	m_spIUtility->TimerStart();
	double f0 = 0;
	double f1 = 123.456789;
	double f2 = 98765.12345678998765432;
	double f3 = 12345678943.98;
	for(int i = 1; i < iInitVal; i++)
	{
		f0 = (f1	/ (double)i) - f2 + (f3 * (double)i);
	}
	m_spIUtility->TimerEnd(/*sbsInfo*/);
/*   	String ss;
  	ss.FormatFloat("Result is ", f0);
    MessageBox(NULL, ss);
*/
	return f0;
}


//---------------------------------------------------------------------------

void __fastcall TForm1::StrangeAttractorClick(TObject *Sender)
{
    StrangeAttractr(50000000);
}
//---------------------------------------------------------------------------
double __fastcall TForm1::StrangeAttractr(long iInitVal)
{
	m_spIUtility->TimerStart();
	//  .
	const double x1 = -1, y1 = -1, z1 = 0;
	const double x2 = -1, y2 =  1, z2 = 0;
	const double x3 =  1, y3 = -1, z3 = 0;
	const double x4 =  1, y4 =  1, z4 = 0;
	//  
	double px1, py1, pz1;
	double px2, py2, pz2;
	double px3, py3, pz3;
	double px4, py4, pz4;

	double ansx = 0, ansy = 0, ansz = 0;

	// double anssumx = 0;
	// double anssumy = 0;
	// double anssumz = 0;

	long iOptnum = iInitVal;// ,     
	double t = 0;
	double dt = 1.0 / iOptnum; //   t   
	double n0, n1, n2, n3; // . 

	for(long i = 0; i < iOptnum; i++)
	{
		n0 = (-t * ((1 - t) * (1 - t))) / 2;
		n1 = (2 - 5 * t * t + 3 * t * t * t) / 2;
		n2 = (t / 2) * (1 + 4 * t - 3 * t * t);
		n3 = -((t * t) / 2) * (1 - t);

		px1 = x1 * n0; py1 = y1 * n0; pz1 = z1 * n0;
		px2 = x2 * n1; py2 = y2 * n1; pz2 = z2 * n1;
		px3 = x3 * n2; py3 = y3 * n2; pz3 = z3 * n2;
		px4 = x4 * n3; py4 = y4	* n3; pz4 = z4 * n3;

		ansx = px1 + px2 + px3 + px4;
		ansy = py1 + py2 + py3 + py4;
		ansz = pz1 + pz2 + pz3 + pz4;

	//	anssumx += ansx;
	//	anssumy += ansy;
	//	anssumz += ansz;
		t += dt;
	}

   	m_spIUtility->TimerEnd(/*sbsInfo*/);
    MessageDlg(String("i: ") + IntToStr(iOptnum)
        + String("xt: ")  + FloatToStr(ansx)
        + String(" yt: ") + FloatToStr(ansy)
        + String(" zt: ") + FloatToStr(ansz),
        mtConfirmation, mbOKCancel, 0);

	return 0;
}
void __fastcall TForm1::StringTestStdClick(TObject *Sender)
{
	m_spIUtility->TimerStart();
	std::string ss;
	for(int i = 0; i < 10000000; i++)
	{
		ss = _T(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>");
		ss += _T(" ");
		ss += _T(" ");
		ss += _T("");
		ss += '\n';
	}
	m_spIUtility->TimerEnd();
}
//---------------------------------------------------------------------------

