using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Text;
using TESTUTILSLib;
using System.Runtime.InteropServices;
using System.Diagnostics;

namespace CSharp
{
	public class CTest1
	{
		int m_i = 0;
		public int GetInt()
		{
			return m_i;
		}
		public void Inc()
		{
			m_i++;
		}
		public void Test(int i, double d, short sh, string sz)
		{
			//i, d, sh, sz;
		}
		public virtual void TestVirtual(int i, double d, short sh, string sz)
		{
		}
	};
	class CTest2 : CTest1
	{
		public override void TestVirtual(int i, double d, short sh, string sz)
		{
		}
	};

	class CBase
	{
		public CBase(int i)
		{
			m_i = i;
			m_pGreat = null;
			m_pLess = null;
			m_pEqual = null;
		}
		readonly int m_i;
		CBase m_pGreat;
		CBase m_pLess;
		CBase m_pEqual;
		private static void AddNode(CBase pRoot, CBase pNew)
		{
			if(pNew.m_i > pRoot.m_i)
			{
				if(pRoot.m_pGreat != null)
					AddNode(pRoot.m_pGreat, pNew);
				else
					pRoot.m_pGreat = pNew;
			}
			else if(pNew.m_i < pRoot.m_i)
			{
				if(pRoot.m_pLess != null)
					AddNode(pRoot.m_pLess, pNew);
				else
					pRoot.m_pLess = pNew;
			}
			else
			{
				if(pRoot.m_pEqual != null)
					AddNode(pRoot.m_pEqual, pNew);
				else
					pRoot.m_pEqual = pNew;
			}
		}

		internal static void TreeSort(int[] item, int left, int right)
		{
			CTestEqualZero Root = new CTestEqualZero(0);
			CBase pNewNode = null;
			for(int i = left; i <= right; i++)
			{
				int iCurrItem = item[i];
				if(iCurrItem < 0)
					pNewNode = new CTestLessZero(iCurrItem);
				else if(iCurrItem == 0)
					pNewNode = new CTestEqualZero(iCurrItem);
				else
					pNewNode = new CTestGreatZero(iCurrItem);
				AddNode(Root, pNewNode);
			}
		}
	};


	class CTestGreatZero : CBase
						   {
		public CTestGreatZero(int i) : base(i)
		{
		}
		protected int m_i1 = 0;
		protected int m_i2 = 0;
		protected int m_i3 = 0;
	};

	class CTestLessZero : CTestGreatZero
	{
		public CTestLessZero(int i) : base(i)
		{
		}
		public int m_i4 = 0;
		public int m_i5 = 0;
	};

	class CTestEqualZero : CTestLessZero
	{
		public CTestEqualZero(int i) : base(i)
		{
		}
		int m_i6 = 0;
		double m_d = 0;
	};

	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button pbMemberAccess;
		private System.Windows.Forms.Button pbMethodCall;
		private System.Windows.Forms.Button pbSortQuick;
		private System.Windows.Forms.Button pbSortBubble;
		private System.Windows.Forms.Button pbComputPi;
		private System.Windows.Forms.Button pbClearMsg;
		private System.Windows.Forms.TextBox tbMsg;
		private System.Windows.Forms.Button pbTreeTest;
		private System.Windows.Forms.Button pbVirtualMehodCall;
		private System.Windows.Forms.Button pbStringTest;
		private System.Windows.Forms.Button pbFloatTest;
		private System.Windows.Forms.Button StrAtrFloatTest;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.pbSortQuick = new System.Windows.Forms.Button();
			this.tbMsg = new System.Windows.Forms.TextBox();
			this.pbVirtualMehodCall = new System.Windows.Forms.Button();
			this.pbMemberAccess = new System.Windows.Forms.Button();
			this.pbSortBubble = new System.Windows.Forms.Button();
			this.pbClearMsg = new System.Windows.Forms.Button();
			this.pbTreeTest = new System.Windows.Forms.Button();
			this.pbMethodCall = new System.Windows.Forms.Button();
			this.pbComputPi = new System.Windows.Forms.Button();
			this.pbStringTest = new System.Windows.Forms.Button();
			this.pbFloatTest = new System.Windows.Forms.Button();
			this.StrAtrFloatTest = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// pbSortQuick
			// 
			this.pbSortQuick.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.pbSortQuick.Location = new System.Drawing.Point(392, 104);
			this.pbSortQuick.Name = "pbSortQuick";
			this.pbSortQuick.Size = new System.Drawing.Size(112, 24);
			this.pbSortQuick.TabIndex = 3;
			this.pbSortQuick.Text = "Quick Sort";
			this.pbSortQuick.Click += new System.EventHandler(this.pbSortQuick_Click);
			// 
			// tbMsg
			// 
			this.tbMsg.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.tbMsg.Location = new System.Drawing.Point(8, 8);
			this.tbMsg.Multiline = true;
			this.tbMsg.Name = "tbMsg";
			this.tbMsg.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.tbMsg.Size = new System.Drawing.Size(376, 288);
			this.tbMsg.TabIndex = 6;
			this.tbMsg.Text = "";
			// 
			// pbVirtualMehodCall
			// 
			this.pbVirtualMehodCall.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.pbVirtualMehodCall.Location = new System.Drawing.Point(392, 72);
			this.pbVirtualMehodCall.Name = "pbVirtualMehodCall";
			this.pbVirtualMehodCall.Size = new System.Drawing.Size(112, 24);
			this.pbVirtualMehodCall.TabIndex = 1;
			this.pbVirtualMehodCall.Text = "Virtual Method Call";
			this.pbVirtualMehodCall.Click += new System.EventHandler(this.pbVirtualMehodCall_Click);
			// 
			// pbMemberAccess
			// 
			this.pbMemberAccess.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.pbMemberAccess.Location = new System.Drawing.Point(392, 8);
			this.pbMemberAccess.Name = "pbMemberAccess";
			this.pbMemberAccess.Size = new System.Drawing.Size(112, 24);
			this.pbMemberAccess.TabIndex = 0;
			this.pbMemberAccess.Text = "Member Access";
			this.pbMemberAccess.Click += new System.EventHandler(this.pbMemberAccess_Click);
			// 
			// pbSortBubble
			// 
			this.pbSortBubble.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.pbSortBubble.Location = new System.Drawing.Point(392, 136);
			this.pbSortBubble.Name = "pbSortBubble";
			this.pbSortBubble.Size = new System.Drawing.Size(112, 24);
			this.pbSortBubble.TabIndex = 4;
			this.pbSortBubble.Text = "Bubble Sort";
			this.pbSortBubble.Click += new System.EventHandler(this.pbSortBubble_Click);
			// 
			// pbClearMsg
			// 
			this.pbClearMsg.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.pbClearMsg.Location = new System.Drawing.Point(8, 304);
			this.pbClearMsg.Name = "pbClearMsg";
			this.pbClearMsg.Size = new System.Drawing.Size(104, 24);
			this.pbClearMsg.TabIndex = 7;
			this.pbClearMsg.Text = "Clear msg";
			this.pbClearMsg.Click += new System.EventHandler(this.pbClearMsg_Click);
			// 
			// pbTreeTest
			// 
			this.pbTreeTest.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.pbTreeTest.Location = new System.Drawing.Point(392, 200);
			this.pbTreeTest.Name = "pbTreeTest";
			this.pbTreeTest.Size = new System.Drawing.Size(112, 24);
			this.pbTreeTest.TabIndex = 5;
			this.pbTreeTest.Text = "Tree Test";
			this.pbTreeTest.Click += new System.EventHandler(this.pbTreeTest_Click);
			// 
			// pbMethodCall
			// 
			this.pbMethodCall.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.pbMethodCall.Location = new System.Drawing.Point(392, 40);
			this.pbMethodCall.Name = "pbMethodCall";
			this.pbMethodCall.Size = new System.Drawing.Size(112, 24);
			this.pbMethodCall.TabIndex = 1;
			this.pbMethodCall.Text = "Method Call";
			this.pbMethodCall.Click += new System.EventHandler(this.pbMethodCall_Click);
			// 
			// pbComputPi
			// 
			this.pbComputPi.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.pbComputPi.Location = new System.Drawing.Point(392, 168);
			this.pbComputPi.Name = "pbComputPi";
			this.pbComputPi.Size = new System.Drawing.Size(112, 24);
			this.pbComputPi.TabIndex = 5;
			this.pbComputPi.Text = "Comput Pi";
			this.pbComputPi.Click += new System.EventHandler(this.pbComputPi_Click);
			// 
			// pbStringTest
			// 
			this.pbStringTest.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.pbStringTest.Location = new System.Drawing.Point(392, 232);
			this.pbStringTest.Name = "pbStringTest";
			this.pbStringTest.Size = new System.Drawing.Size(112, 24);
			this.pbStringTest.TabIndex = 8;
			this.pbStringTest.Text = "String Test";
			this.pbStringTest.Click += new System.EventHandler(this.pbStringTest_Click);
			// 
			// pbFloatTest
			// 
			this.pbFloatTest.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.pbFloatTest.Location = new System.Drawing.Point(392, 264);
			this.pbFloatTest.Name = "pbFloatTest";
			this.pbFloatTest.Size = new System.Drawing.Size(112, 24);
			this.pbFloatTest.TabIndex = 9;
			this.pbFloatTest.Text = "Float Test";
			this.pbFloatTest.Click += new System.EventHandler(this.pbFloatTest_Click);
			// 
			// StrAtrFloatTest
			// 
			this.StrAtrFloatTest.Location = new System.Drawing.Point(392, 296);
			this.StrAtrFloatTest.Name = "StrAtrFloatTest";
			this.StrAtrFloatTest.Size = new System.Drawing.Size(112, 24);
			this.StrAtrFloatTest.TabIndex = 10;
			this.StrAtrFloatTest.Text = "Strange Atr. Test";
			this.StrAtrFloatTest.Click += new System.EventHandler(this.StrAtrFloatTest_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(512, 333);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.StrAtrFloatTest,
																		  this.pbFloatTest,
																		  this.pbStringTest,
																		  this.pbVirtualMehodCall,
																		  this.pbTreeTest,
																		  this.pbClearMsg,
																		  this.tbMsg,
																		  this.pbComputPi,
																		  this.pbSortBubble,
																		  this.pbSortQuick,
																		  this.pbMethodCall,
																		  this.pbMemberAccess});
			this.Name = "Form1";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		const int c_iCount = 1000000000;
		const string sInputFile = @"..\..\..\q3.ZIP";
		private void pbMemberAccess_Click(object sender, System.EventArgs e)
		{
			CTest1 test1 = new CTest1();
			m_spIUtility.TimerStart();
			for(int i = 0; i < c_iCount; i++)
			{
				test1.Inc();
			}
			m_spIUtility.TimerEnd();
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{

		}

		private Utility m_spIUtility = new Utility();

		private void pbMethodCall_Click(object sender, System.EventArgs e)
		{
			MehodCallClick(c_iCount);
		}
		void MehodCallClick(int iInitVal)
		{
			CTest1 test1 = new CTest1();
			m_spIUtility.TimerStart();
			for(int i = 0; i < iInitVal; i++)
			{
				test1.Test(i, 3.123, 1, "Some string");
			}
			m_spIUtility.TimerEnd(/*sbsInfo*/);
		}

		enum SORT_TYPE { stQuickSort, stBubbleSort, stTreeSort };
		
		//     LoadData    
		//       ,
		//        CLR.
		//          
		//  Win32 API-.      
		//   .
		//
		//     ,   CLR   
		//    (   ) 
		//  . -,     ,
		// ,  4  ( int-)  .
		//
		//      
		//  DLL-.      
		//  (int, byte, double...)   ,  
		//  DLL       (..    C/C++).
		//        int-.
		//            
		//      .
		//       (  C++) 
		//       unsafe-.
//		private void LoadData(string szFileName, ref int[] iAryData, int ciElemCnt)
//		{
//			FileStream fs = new FileStream(szFileName, FileMode.Open, FileAccess.Read, FileShare.Read);
//			BinaryReader brInputFile = new BinaryReader(fs);
//			//byte[] AryBytes = brInputFile.ReadBytes(ciByts);
//			int i;
//			iAryData = new int[ciElemCnt];
//			for(i = 0; i < ciElemCnt; i++)
//				iAryData[i] = brInputFile.ReadInt32();
//		}
// >>
		//     CreateFile
		enum DESIRED_ACCESS : ulong 
		{
			GENERIC_READ    = 0x80000000L,
			GENERIC_WRITE   = 0x40000000L,
			GENERIC_EXECUTE = 0x20000000L,
			GENERIC_ALL     = 0x10000000L,
		};
		enum SHARE_MODE : ulong 
		{
			FILE_SHARE_READ   = 0x00000001,
			FILE_SHARE_WRITE  = 0x00000002,
			FILE_SHARE_DELETE = 0x00000004
		};
		enum FLAGSANDATTRIBUTES : ulong 
		{
			FILE_ATTRIBUTE_READONLY            = 0x00000001,
			FILE_ATTRIBUTE_HIDDEN              = 0x00000002,
			FILE_ATTRIBUTE_SYSTEM              = 0x00000004,
			FILE_ATTRIBUTE_DIRECTORY           = 0x00000010,
			FILE_ATTRIBUTE_ARCHIVE             = 0x00000020,
			FILE_ATTRIBUTE_ENCRYPTED           = 0x00000040,
			FILE_ATTRIBUTE_NORMAL              = 0x00000080,
			FILE_ATTRIBUTE_TEMPORARY           = 0x00000100,
			FILE_ATTRIBUTE_SPARSE_FILE         = 0x00000200,
			FILE_ATTRIBUTE_REPARSE_POINT       = 0x00000400,
			FILE_ATTRIBUTE_COMPRESSED          = 0x00000800,
			FILE_ATTRIBUTE_OFFLINE             = 0x00001000,
			FILE_ATTRIBUTE_NOT_CONTENT_INDEXED = 0x00002000,
		};
		enum CREATION_DISPOSITION : ulong 
		{ 
			CREATE_NEW = 1, CREATE_ALWAYS, OPEN_EXISTING, 
			OPEN_ALWAYS, TRUNCATE_EXISTING
		};

		const int INVALID_HANDLE_VALUE = -1;
		const uint INVALID_FILE_SIZE = 0xFFFFFFFF;

		//  Win32 API- CreateFile
		[DllImport("Kernel32.dll")]
		private extern static int CreateFile(
			string lpFileName,							// LPCTSTR - file name
			uint daDesiredAccess,						// DWORD - access mode
			uint smShareMode,							// DWORD - share mode
			int lpSecurityAttributes,					// LPSECURITY_ATTRIBUTES - SD
			CREATION_DISPOSITION dwCreationDisposition,	// DWORD - how to create
			uint dwFlagsAndAttributes,					// DWORD - file attributes
			int hTemplateFile							// HANDLE - handle to template file
		);

		//  Win32 API- ReadFile
		[DllImport("Kernel32.dll")]
		private extern static bool ReadFile(
			int hFile,						// handle to file
			int[] lpBuffer,					// data buffer
			uint nNumberOfBytesToRead,		// number of bytes to read
			ref uint lpNumberOfBytesRead,	// number of bytes read
			int lpOverlapped				// overlapped buffer
		);

		private void LoadData(string szFileName, ref int[] iAryData, int ciElemCnt)
		{
			//       Win32 API- CreateFile
			int hInputFile = CreateFile(szFileName, (uint)DESIRED_ACCESS.GENERIC_READ, 
				(uint)SHARE_MODE.FILE_SHARE_READ, 0, 
				CREATION_DISPOSITION.OPEN_EXISTING, 
				(uint)FLAGSANDATTRIBUTES.FILE_ATTRIBUTE_NORMAL, 0);
			if(hInputFile == INVALID_HANDLE_VALUE)
				throw new System.Exception("Can't open test file");
			//        
			iAryData = new int[ciElemCnt];
			uint dwNumberOfBytesRead = 0;
			//           Win32 API- ReadFile
			ReadFile(hInputFile, iAryData, (uint)ciElemCnt * 4, ref dwNumberOfBytesRead, 0);
			if((int)dwNumberOfBytesRead != ciElemCnt * 4)
				throw new System.Exception("You need file not less 100 MB.");
		}

		private void SortTest(string szFileName, SORT_TYPE SortType, int ciByts, int iIterationsCnt)
		{
			int ciElemCnt = ciByts / 4; //sizeof(int)
			int[] iAryData = null;
			LoadData(szFileName, ref iAryData, ciElemCnt);
			int[] iAryWork;
				
			iAryWork = (int[])iAryData.Clone();
			int i;
			MessageBox.Show("Go?!!!", "Sort Test.");
			m_spIUtility.TimerStart();
			switch(SortType)
			{
			case SORT_TYPE.stQuickSort:
				for(i = 0; i < iIterationsCnt; i++)
				{
					if(i > 0)
						iAryWork = (int[])iAryData.Clone();
					QuickSortInt(iAryWork, 0, ciElemCnt - 1);
					//Array.Sort(iAryWork);
				}
				break;
			case SORT_TYPE.stBubbleSort:
				for(i = 0; i < iIterationsCnt; i++)
				{
					if(i > 0)
						iAryWork = (int[])iAryData.Clone();
					BubbleSort(iAryWork, 0, ciElemCnt - 1);
				}
				break;
			case SORT_TYPE.stTreeSort:
				for(i = 0; i < iIterationsCnt; i++)
				{
					if(i > 0)
						iAryWork = (int[])iAryData.Clone();
					CBase.TreeSort(iAryWork, 0, ciElemCnt - 1);
				}
				break;
			}
			m_spIUtility.TimerEnd(/*sbsInfo*/);
		}

		//         
		// ,    ,
		//   "Bubble Sort"     () .
		//    unsafe-.    runtime-.
		unsafe static void BubbleSort(int[] aitem, int left, int right)
		{
			fixed(int * item = aitem)
			{
				BubbleSort(item, left, right);
			}
		}

		unsafe static void BubbleSort(int * item, int left, int right)
//		static void BubbleSort(int[] item, int left, int right)
		{
			int i, j, x;
			for(i = left + 1; i <= right; i++)
				for(j = right; j >= i; j--)
					if(item[j - 1] > item[j])
					{
						x  = item[j];
						item[j] = item[j - 1];
						item[j - 1] = x;
					}
		}

		//         
		// ,    ,
		//   "Quick Sort"     () .
		//    unsafe-.    runtime-.
		unsafe static void QuickSortInt(int[] aitem, int left, int right)
		{
			fixed(int * item = aitem)
			{
				QuickSortInt(item, left, right);
			}
		}

		unsafe static void QuickSortInt(int * item, int left, int right)
//		static void QuickSortInt(int[] item, int left, int right)
		{
			unchecked 
			{
				int i, j;
				int center;
				int x;
				i = left;
				j = right;	
				center = item[(left + right) / 2];
				while(i <= j)
				{
					while (item[i] < center && i < right)
						i++;
					while (item[j] > center && j > left)
						j--;

					if (i<=j)
					{
						x  = item[i];
						item[i] = item[j];
						item[j] = x;
						i++;
						j--;
					}
				} 
				if(left  < j)
					QuickSortInt(item, left, j);
				if(right > i)
					QuickSortInt(item, i, right);
			}
		}

		private void pbSortQuick_Click(object sender, System.EventArgs e)
		{
			SortTest(sInputFile, SORT_TYPE.stQuickSort, 100000000, 1);
		}

		private void pbSortBubble_Click(object sender, System.EventArgs e)
		{
			SortTest(sInputFile, SORT_TYPE.stBubbleSort, 150000, 1);
//			int[] arr = new int[] {4,23,5,-1,3,6,2,45,63,3,3,453,43,2,3};
//			BubbleSort(arr, 0, arr.Length - 1);
		}
		
		public static string pi(int digits)
		{
			if (digits > 54900)
				throw new System.Exception("n must be <= 54900");
			
			StringBuilder pi = new StringBuilder(digits);
			string[] zero = { "0", "00", "000" };
			int d = 0, e, b, g, r;
			int c = (digits / 4 + 1) * 14;
			int[] a = new int[c];
			int f = 10000;

			for(int i = 0; i < a.Length; i++)
				a[i] = 20000000;

			while((b = c -= 14) > 0)
			{
				d = e = d % f;

				while(--b > 0)
				{
					d = d * b + a[b];
					g = (b << 1) - 1;
					a[b] = (d % g) * f;
					d /= g;
				}

				r = e + d / f;

				if (r < 1000)
					pi.Append(zero[r > 99 ? 0 : r > 9 ? 1 : 2]);
				pi.Append(r);
			}
			return pi.ToString();
		}

		private void pbComputPi_Click(object sender, System.EventArgs e)
		{
			const int iDigit = 15000;
			m_spIUtility.TimerStart();
			string sPi = pi(iDigit);
			m_spIUtility.TimerEnd();
			tbMsg.Text = "The " + iDigit.ToString() + " of Pi is " + sPi;
		}

		private void pbClearMsg_Click(object sender, System.EventArgs e)
		{
			tbMsg.Text = "";
		}

		private void pbTreeTest_Click(object sender, System.EventArgs e)
		{
			SortTest(sInputFile, SORT_TYPE.stTreeSort, 10000000, 1);
		}
		void VirtualMehodCallClick(int iInitVal)
		{
			CTest2 test2 = new CTest2();
			CTest1 test1 = test2;
			m_spIUtility.TimerStart();
			for(int i = 0; i < iInitVal; i++)
			{
				test1.TestVirtual(i, 3.123, 1, "Some string");
			}
			m_spIUtility.TimerEnd(/*sbsInfo*/);
		}

		private void pbVirtualMehodCall_Click(object sender, System.EventArgs e)
		{
			VirtualMehodCallClick(c_iCount);
		}

		private void pbStringTest_Click(object sender, System.EventArgs e)
		{
			m_spIUtility.TimerStart();
			StringBuilder ss = new StringBuilder(1000);
			for(int i = 0; i < 10000000; i++)
			{
				ss.Length = 0;
				ss.Append(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>");
				ss.Append(" ");
				ss.Append(" ");
				ss.Append("");
				ss.Append('\n');
			}
			m_spIUtility.TimerEnd();
		}

		private double FloatTest(int iInitVal)
		{
			m_spIUtility.TimerStart();
			double f0 = 0;
			double f1 = 123.456789;
			double f2 = 98765.12345678998765432;
			double f3 = 12345678943.98;
			for(int i = 1; i < iInitVal; i++)
			{
				f0 = (f1 / (double)i) - f2 + (f3 * (double)i);
			}
			m_spIUtility.TimerEnd();
			StringBuilder ss = new StringBuilder();
			ss.AppendFormat("Result is {0,0:f}", f0);
			MessageBox.Show(ss.ToString());
			return f0;	  
			}

		private void pbFloatTest_Click(object sender, System.EventArgs e)
		{
			FloatTest(1000000000);
		}

		private void StrAtrFloatTest_Click(object sender, System.EventArgs e)
		{
			StrangeAttractr(50000000);
		}

		private void StrangeAttractr(long iInitVal)
		{
			m_spIUtility.TimerStart();
			//  .
			double x1 = -1, y1 = -1, z1 = 0;
			double x2 = -1, y2 =  1, z2 = 0;
			double x3 =  1, y3 = -1, z3 = 0;
			double x4 =  1, y4 =  1, z4 = 0;
			//  
			double px1 = 0, py1 = 0, pz1 = 0;
			double px2 = 0, py2 = 0, pz2 = 0;
			double px3 = 0, py3 = 0, pz3 = 0;
			double px4 = 0, py4 = 0, pz4 = 0;

			double ansx = 0;
			double ansy = 0;
			double ansz = 0;

			// double anssumx = 0;
			// double anssumy = 0;
			// double anssumz = 0;

			long iOptnum = iInitVal;// ,     
			double t = 0;
			double dt = (double)1 / (double)iOptnum; //   t   
			double n0 = 0 , n1 = 0, n2 = 0, n3 = 0; // . 

			for (long i = 0; i < iOptnum; i++) 
			{
		
				n0 = ( -t * (( 1 - t) * (1 - t))) / 2;
				n1 = ( 2 -5 * t * t + 3 * t * t * t) / 2;
				n2 = ( t / 2) * (1 + 4 * t - 3 * t * t);
				n3 = -(( t * t) / 2) * (1 - t);
		

				px1 = x1 * n0;
				py1 = y1	* n0;
				pz1 = z1	* n0;

				px2 = x2 * n1;
				py2 = y2	* n1;
				pz2 = z2	* n1;


				px3 = x3 * n2;
				py3 = y3	* n2;
				pz3 = z3	* n2;

				px4 = x4 * n3;
				py4 = y4	* n3;
				pz4 = z4	* n3;

				ansx = px1 + px2 + px3 + px4; 
				ansy = py1 + py2 + py3 + py4; 
				ansz = pz1 + pz2 + pz3 + pz4; 
				t += dt;
			}

			m_spIUtility.TimerEnd(/*sbsInfo*/);

			StringBuilder ss = new StringBuilder();
			ss.AppendFormat("Result is x:{0}, y:{1}, z:{2}", ansx, ansy, ansz);
			MessageBox.Show(ss.ToString());

				
		}
	}
}
