unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleServer, TESTUTILSLib_TLB, Math;

type
    SORT_TYPE = (stQuickSort, stBubbleSort, stTreeSort);
    TForm1 = class(TForm)
        pbMemberAccess: TButton;
    pbMethodCall: TButton;
    pbSortQuick: TButton;
    pbSortBubble: TButton;
    pbComputPi: TButton;
    Memo1: TMemo;
    Button1: TButton;
    pbTreeTest: TButton;
    pbVirtualMehodCall: TButton;
    pbStringTest: TButton;
    pbFloatTest: TButton;
    pbStringTest2: TButton;
    Button2: TButton;
    Utility1: TUtility;
    procedure pbMemberAccessClick(Sender: TObject);
    procedure pbMethodCallClick(Sender: TObject);
    procedure MehodCallClick(iInitVal : integer);
    procedure VirtualMehodCallClick(iInitVal : integer);
    procedure pbSortQuickClick(Sender: TObject);
    procedure SortTest(const szFileName : PChar; const SortType : SORT_TYPE;
        const ciByts, iIterationsCnt : Integer);
    procedure pbSortBubbleClick(Sender: TObject);
    procedure pbComputPiClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure pbTreeTestClick(Sender: TObject);
    procedure pbVirtualMehodCallClick(Sender: TObject);
    procedure pbStringTestClick(Sender: TObject);
    procedure pbFloatTestClick(Sender: TObject);
    FUNCTION FloatTest(iInitVal : Integer) : double;
    procedure pbStringTest2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure StrAttractorTest(iInitVal : int64);
    private
        { Private declarations }
    public
        { Public declarations }
    end;

    CTest1 = class
    public
        //CTest1() : m_i(0) {}
        m_i : Integer;
        constructor Create;
        function GetInt() : Integer;
        procedure Inc_m_i();
	procedure Test(i : Integer; d : double; sh : Smallint; const sz : string);
 	procedure TestVirtual(i : Integer; d : double; sh : Smallint; const sz : string); virtual;

        procedure Add(i : Integer);
    end;

    CTest2 = class(CTest1)
    public
     	procedure TestVirtual(i : Integer; d : double; sh : Smallint; const sz : string); override;
    end;

	CBase = class
    public
		m_i : Integer;
		m_pGreat : CBase;
		m_pLess : CBase;
		m_pEqual : CBase;

		constructor Create(i : Integer);
        destructor Destroy; override;
    end;

	CTestGreatZero = class(CBase)
    public
		constructor Create(i : Integer);
    protected
        m_i1 : Integer;
		m_i2 : Integer;
		m_i3 : Integer;
	end;

	CTestLessZero = class(CTestGreatZero)
    public
		m_i4 : Integer;
		m_i5 : Integer;

		constructor Create(i : Integer);
	end;

	CTestEqualZero = class(CTestLessZero)
    public
		m_i6 : Integer;
		m_d : double;

		constructor Create(i : Integer);
	end;

const
    c_iCount = 1000000000;
    sInputFile : PChar = '..\q3.ZIP';

var
  Form1: TForm1;


implementation

{$R *.dfm}

{ CTest1 }

procedure CTest1.Add(i: Integer);
begin
    m_i := m_i + i;
end;

constructor CTest1.Create;
begin
    m_i := 0;
end;

function CTest1.GetInt: Integer;
begin
    Result := m_i;
end;

procedure CTest1.Inc_m_i;
begin
    Inc(m_i);
    //m_i := m_i + 1;
end;

procedure TForm1.pbMemberAccessClick(Sender: TObject);
var
    test1 : CTest1;
    i : Integer;
begin
    test1 := CTest1.Create();
    Utility1.TimerStart();
	for i := 0 To c_iCount do  begin
        test1.Inc_m_i();
    end;
    Utility1.TimerEnd();
end;

procedure TForm1.pbMethodCallClick(Sender: TObject);
begin
    MehodCallClick(c_iCount);
end;

procedure TForm1.MehodCallClick(iInitVal: integer);
var
    test1 : CTest1;
    i : Integer;
begin
    Utility1.TimerStart();
    test1 := CTest1.Create();
	for i := 0 To c_iCount do  begin
        test1.Test(i, 3.123, 1, 'Some string');
    end;
    Utility1.TimerEnd();
end;

procedure CTest1.Test(i: Integer; d: double; sh: Smallint; const sz: string);
begin
    //
end;

procedure CTest1.TestVirtual(i: Integer; d: double; sh: Smallint;
  const sz: string);
begin
    //
end;

{ CTest2 }

procedure CTest2.TestVirtual(i: Integer; d: double; sh: Smallint; const sz: string);
begin
  //inherited;
end;

procedure BubbleSort(var item : Array of Integer; left, right : Integer);
var
    i, j, x : Integer;
begin
	for i := left + 1 to right do
		for j := right downto i do
			if item[j - 1] > item[j] then
			begin
				x  := item[j];
				item[j] := item[j - 1];
				item[j - 1] := x;
            end;
end;

procedure QuickSortInt(var item : Array of Integer; left, right : Integer);
var
    i, j, center, x : Integer;
begin
    i := left;
    j := right;
    center := item[(left + right) div 2];
    while i <= j do
    begin
        while (item[i] < center) AND (i < right) do
            Inc(i);
        while (item[j] > center) AND (j > left) do
            Dec(j);

        if i <= j then
        begin
            x := item[i];
            item[i] := item[j];
            item[j] := x;
            Inc(i);
            Dec(j);
        end;
    end;
    if left < j then
        QuickSortInt(item, left, j);
    if right > i then
        QuickSortInt(item, i, right);
end;

procedure AddNode(pRoot, pNew : CBase);
begin
    if pNew.m_i > pRoot.m_i then
    begin
        if pRoot.m_pGreat <> nil then
            AddNode(pRoot.m_pGreat, pNew)
        else
            pRoot.m_pGreat := pNew;
    end else if pNew.m_i < pRoot.m_i then begin
        if pRoot.m_pLess <> nil then
            AddNode(pRoot.m_pLess, pNew)
        else
            pRoot.m_pLess := pNew;
    end else begin
        if pRoot.m_pEqual <> nil then
            AddNode(pRoot.m_pEqual, pNew)
        else
            pRoot.m_pEqual := pNew;
    end;
end;

procedure TreeSort(var item : Array of Integer; left, right : Integer);
var
    Root : CTestEqualZero;
    pNewNode : CBase;
    iCurrItem : Integer;
    i : Integer;
begin
    Root := CTestEqualZero.Create(0);
    try
        //pNewNode := nil;
        for i := left to right do
        begin
            iCurrItem := item[i];
            if iCurrItem < 0 then
                pNewNode := CTestLessZero.Create(iCurrItem)
            else if iCurrItem = 0 then
                pNewNode := CTestEqualZero.Create(iCurrItem)
            else
                pNewNode := CTestGreatZero.Create(iCurrItem);
            AddNode(Root, pNewNode);
        end;
    finally
        Root.Free;
    end;
end;

{ CBase }

constructor CBase.Create(i: Integer);
begin
    m_i := i;
    m_pGreat := nil;
    m_pLess := nil;
    m_pEqual := nil;
end;

destructor CBase.Destroy;
begin
    m_pGreat.Free;
    m_pLess.Free;
    m_pEqual.Free;
end;

{ CTestGreatZero }

constructor CTestGreatZero.Create(i: Integer);
begin
    inherited Create(i);
    m_i1 := 0;
    m_i2 := 0;
    m_i3 := 0;
end;

{ CTestLessZero }

constructor CTestLessZero.Create(i: Integer);
begin
    inherited Create(i);
    m_i4 := 0;
    m_i5 := 0;
end;

{ CTestEqualZero }

constructor CTestEqualZero.Create(i: Integer);
begin
    m_i6 := 0;
    m_d := 0;
end;

procedure TForm1.SortTest(const szFileName: PChar;
  const SortType: SORT_TYPE; const ciByts, iIterationsCnt: Integer);
var
    ciElemCnt : Integer;
    hInputFile : THandle;
    iAryData, iAryWork : Array of Integer;
    dwNumberOfBytesRead : DWORD;
    i : Integer;
begin
    ciElemCnt := ciByts div 4;
	hInputFile := CreateFile(szFileName, GENERIC_READ, FILE_SHARE_READ,
        nil, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
	if hInputFile = INVALID_HANDLE_VALUE then
    begin
        ShowMessage('Cannot open the "' + szFileName + '" file!');
        exit;
    end;

    SetLength(iAryData, ciElemCnt);
    SetLength(iAryWork, ciElemCnt);

	ReadFile(hInputFile, iAryData[0], ciByts, dwNumberOfBytesRead, nil);
	ASSERT(Integer(dwNumberOfBytesRead) = ciByts);

    CopyMemory(iAryWork, iAryData, ciByts);
    ShowMessage('Go?!');
    Utility1.TimerStart();
    case SortType of
    stQuickSort:
        for i := 0 to iIterationsCnt - 1 do
        begin
            if i > 0 then
                CopyMemory(iAryWork, iAryData, ciByts);
            QuickSortInt(iAryWork, 0, ciElemCnt - 1);
        end;
    stBubbleSort:
        for i := 0 to iIterationsCnt - 1 do
        begin
            if i > 0 then
                CopyMemory(iAryWork, iAryData, ciByts);
            BubbleSort(iAryWork, 0, ciElemCnt - 1);
        end;
    stTreeSort:
        for i := 0 to iIterationsCnt - 1 do
        begin
            if i > 0 then
                CopyMemory(iAryWork, iAryData, ciByts);
            TreeSort(iAryWork, 0, ciElemCnt - 1);
        end;
    end;
	Utility1.TimerEnd();

	CloseHandle(hInputFile);
end;

procedure TForm1.pbSortQuickClick(Sender: TObject);
begin
    SortTest(sInputFile, stQuickSort, 100000000, 1);
end;

procedure TForm1.pbSortBubbleClick(Sender: TObject);
//var
//    arr : Array[0..14] of Integer;
//    i : Integer;
begin
    SortTest(sInputFile, stBubbleSort, 150000, 1);
//    for i := 0 to 14 do
//        arr[i] := Random(99);
//    BubbleSort(arr, 0, 14);
end;
function pi(digits : Integer) : string;
var
    pi : string;
    zero : Array[0..2] of string;
    i, f, c, d, e, b, g, r : Integer;
    a : Array of Integer;
begin
    if (digits > 54900) then
        raise Exception.Create('n must be <= 54900');

    zero[0] := '0';
    zero[1] := '00';
    zero[2] := '000';
    d := 0;

    c := (digits div 4 + 1) * 14;
    SetLength(a, c);
    f := 10000;

    for i := 0 to c - 1 do
        a[i] := 20000000;

    c := c - 14;
    b := c;
    while b > 0 do
    begin
        d := d mod f;
        e := d;

        Dec(b);
        while(b > 0) do
        begin
            d := d * b + a[b];
            g := (b shl 1) - 1;
            a[b] := (d mod g) * f;
            d := d div g;
            Dec(b);
        end;

        r := e + d div f;

        if (r < 1000) then
            pi := pi + zero[IfThen(r > 99, 0, IfThen(r > 9, 1, 2))];
        pi := pi + IntToStr(r);
        c := c - 14;
        b := c;
    end;
    Result := pi;
end;

procedure TForm1.pbComputPiClick(Sender: TObject);
const iDigit : Integer = 15000;
var
    sPi : string;
begin
    Memo1.Text := '';
    Utility1.TimerStart();
    sPi := pi(iDigit);
    Utility1.TimerEnd();
    Memo1.Text := 'The ' + IntToStr(iDigit) + ' of Pi is ' + sPi;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
    Memo1.Text := '';
end;

procedure TForm1.pbTreeTestClick(Sender: TObject);
begin
    SortTest(sInputFile, stTreeSort, 10000000, 1);
end;

procedure TForm1.pbVirtualMehodCallClick(Sender: TObject);
begin
    VirtualMehodCallClick(c_iCount);
end;

procedure TForm1.VirtualMehodCallClick(iInitVal: integer);
var
    test1 : CTest1;
    i : Integer;
begin
    Utility1.TimerStart();
    test1 := CTest2.Create();
	for i := 0 To c_iCount do  begin
        test1.TestVirtual(i, 3.123, 1, 'Some string');
    end;
    Utility1.TimerEnd();
end;


procedure TForm1.pbStringTestClick(Sender: TObject);
var
    ss : string;
    i : Integer;
begin
    Utility1.TimerStart();
	for i := 0 To 10000000 - 1 do  begin
        ss := '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>';
        ss := ss + ' ';
        ss := ss + ' ';
        ss := ss + '';
        ss := ss + #10; //'\n'
    end;
    Utility1.TimerEnd();
    ShowMessage(ss);
end;

procedure TForm1.pbFloatTestClick(Sender: TObject);
begin
    FloatTest(1000000000);
end;

function TForm1.FloatTest(iInitVal: Integer): double;
var
    f0, f1, f2, f3 : double;
    i : Integer;
begin
    Utility1.TimerStart();
    f0 := 0;
    f1 := 123.456789;
    f2 := 98765.12345678998765432;
    f3 := 12345678943.98;
	for i := 1 To iInitVal - 1 do  begin
        f0 := (f1 / i) - f2 + (f3 * i);
    end;
    Utility1.TimerEnd();
    ShowMessage(Format('Result is %n', [f0]));
    FloatTest := f0;
end;

function StrFastCopy( s1 : PChar; const s : string ) :PChar;
var
   len : Integer;
begin
  len := Length(s);
  StrMove(S1, PChar(s), len);
  Result := s1 + len;
end;

procedure TForm1.pbStringTest2Click(Sender: TObject);
var
    s0, s1 : PChar;
    //ss : string;
    i : Integer;
begin
    Utility1.TimerStart();
    GetMem(s0, 1000 );
    for i := 0 To 10000000 - 1 do
    begin
        s1 := StrFastCopy(s0, '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>');
        s1 := StrFastCopy(s1, ' ');
        s1 := StrFastCopy(s1, ' ');
        s1 := StrFastCopy(s1, '');
        StrFastCopy(s1, #10);
        s1 := s0;
        //ss := s0;
    end;
    Utility1.TimerEnd();
    //ShowMessage(ss);
    ShowMessage(s1);
    FreeMem(s0);
end;

{
procedure TForm1.pbStringTest2Click(Sender: TObject);
var
    ss, s1 : PChar;
    i : Integer;
begin
    Utility1.TimerStart();
    GetMem(ss, 1000);
    for i := 0 To 10000000 - 1 do begin
       s1 := StrECopy(ss, '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>');
       s1 := StrECopy(s1, ' ');
       s1 := StrECopy(s1, ' ');
       s1 := StrECopy(s1, '');
       s1 := StrECopy(s1, #10);
       s1 := ss;
    end;
    Utility1.TimerEnd();
    ShowMessage(s1);
    FreeMem(ss);
end;
}
procedure TForm1.FormCreate(Sender: TObject);
begin
    IsMultiThread := True;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
        StrAttractorTest(50000000);
end;

procedure TForm1.StrAttractorTest(iInitVal : int64);
  const x1 : double  = -1;
  const y1 : double = -1;
  const z1 : double= 0;
  const x2 : double= -1;
  const y2 : double  =  1;
  const z2 : double= 0;
  const x3 : double=  1;
  const y3 : double = -1;
  const z3 : double = 0;
  const x4 : double=  1;
  const y4 : double=  1;
  const z4 : double= 0;
var
  //  
  px1, py1, pz1,
  px2, py2, pz2,
  px3 , py3, pz3,
  px4, py4, pz4 : double;

  ansx, ansy, ansz : double;
  iOptnum : Longint;// ,     
  t, dt :double ; //   t   
  n0, n1, n2, n3 : double ; // . 
  i: longint;
begin
  Utility1.TimerStart();
  ansx := 0; ansy := 0; ansz := 0;

  iOptnum := iInitVal;// ,     
  t := 0;
  dt := 1.0 / iOptnum; //   t   
  i := 0;
  while i < iOptnum do
  begin
          n0:= (-t * ((1 - t) * (1 - t))) / 2;
          n1:= (2 - 5 * t * t + 3 * t * t * t) / 2;
          n2:= (t / 2) * (1 + 4 * t - 3 * t * t);
          n3:= -(( t * t) / 2) * (1 - t);

          px1:= x1 * n0; py1:= y1 * n0; pz1:= z1 * n0;
          px2:= x2 * n1; py2:= y2 * n1; pz2:= z2 * n1;
          px3:= x3 * n2; py3:= y3 * n2; pz3:= z3 * n2;
          px4:= y4 * n3; py4:= y4 * n3; pz4:= z4 * n3;

          ansx:= px1 + px2 + px3 + px4;
          ansy:= py1 + py2 + py3 + py4;
          ansz:= pz1 + pz2 + pz3 + pz4;

  //	anssumx += ansx;
  //	anssumy += ansy;
  //	anssumz += ansz;
          t:= t + dt;
          i:= i + 1;
  end;
  Utility1.TimerEnd();
  MessageDlg('i: ' + IntToStr(i) + 'xt: ' + FloatToStr(ansx) +' yt: ' + FloatToStr(ansy)+ ' yt: ' + FloatToStr(ansz), mtConfirmation, [mbOk], 0);
end;

end.
