// Utility.cpp : Implementation of CUtility
#include "stdafx.h"
#include "TestUtils.h"
#include "Utility.h"

/////////////////////////////////////////////////////////////////////////////
// CUtility

STDMETHODIMP CUtility::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_IUtility
	};
	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

STDMETHODIMP CUtility::TimerStart()
{
	QueryPerformanceCounter(&m_liStart);
	return S_OK;
}

void Show(double dblTime)
{
	CComVariant svTmp(dblTime);
	svTmp.ChangeType(VT_BSTR);
	TCHAR szFmtStr[0x100];
	USES_CONVERSION;
	wsprintf(szFmtStr, _T("   %s .\n")/*, OLE2T(strInfo)*/, OLE2T(svTmp.bstrVal));
	MessageBox(::GetActiveWindow(), szFmtStr, _T("  "), 0);
}

STDMETHODIMP CUtility::TimerEnd(/*BSTR strInfo*/)
{
	LARGE_INTEGER liEnd;
	QueryPerformanceCounter(&liEnd);
	LARGE_INTEGER liFreq;
	QueryPerformanceFrequency(&liFreq);
	//     LowPart  ,
	//   QuadPart.
	//  liFreq   LowPart ,    QuadPart.
	Show((double)(liEnd.QuadPart - m_liStart.QuadPart)/(double)liFreq.QuadPart);
	return S_OK;
}
