// Utility.h : Declaration of the CUtility

#ifndef __UTILITY_H_
#define __UTILITY_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CUtility
class ATL_NO_VTABLE CUtility : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CUtility, &CLSID_Utility>,
	public ISupportErrorInfo,
	public IDispatchImpl<IUtility, &IID_IUtility, &LIBID_TESTUTILSLib>
{
public:
	CUtility()
	{
		m_pUnkMarshaler = NULL;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_UTILITY)
DECLARE_GET_CONTROLLING_UNKNOWN()

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CUtility)
	COM_INTERFACE_ENTRY(IUtility)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}

	void FinalRelease()
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IUtility
public:
	STDMETHOD(TimerStart)();
	STDMETHOD(TimerEnd)(/*BSTR strInfo*/);
public:
	LARGE_INTEGER m_liStart;
};

#endif //__UTILITY_H_
