//
//	File:	 test.cpp
//	Date:	 12/2/2001
//
//	Description:
//		NONE
//
//	Update History:
//		NONE
//
//	Lase Modification:
//		$Author$:$Date$
//
/////////////////////////////////////////////////////////////////////////////

#include <windows.h>
#include <iostream.h>
#include <stdio.h>
#include <string.h>
#include <malloc.h>

#include "test.h"

/////////////////////////////////////////////////////////////////////////////

CTimer g_timer;

/////////////////////////////////////////////////////////////////////////////
//

void Usage()
{
	cerr << "Select Test\n"
			"\t1. Member Access\n"
			"\t2. Method Call (4 params)\n"
			"\t3. Virtual Method Call (params)\n"
			"\t4. Quick Sort\n"
			"\t5. Bubble Sort\n"
			"\t6. Tree Test\n"
			"\t7. Comput PI\n"
			"\t8. String Test\n"
			"\t9. Float Test\n"
			"\t0. Float Test2 Strng. Attr.\n"
			"\th. This text\n"
			"\tq. Quit\n" << endl;
}

/////////////////////////////////////////////////////////////////////////////

void Test()
{
	bool bDone = false;
	while (!bDone)
	{
		char ch;

		cin >> ch;
		switch (ch)
		{
		case 27:
		case 'q':
		case 'Q':
			bDone = true;
			break;

		case 'h':
		case 'H':
			Usage();
			break;

		case '1':
			PerformMemberAccessTest();
			break;

		case '2':
			PerformMethodCallTest();
			break;

		case '3':
			PerformVirtualMehodCallTest();
			break;

		case '4':
			PerformeQuickSortTest();
			break;

		case '5':
			PerformeBubbleSortTest();
			break;

		case '6':
			PerformeTreeTest();
			break;

		case '7':
			PerformPiTest();
			break;

		case '8':
			PerformStringTest();
			break;

		case '9':
			PerformFloatTest();
			break;
		case '0':
			PerformAtrTest();
			break;

		}
	}
}


int main()
{
	Usage();
	try
	{
		Test();
	}
	catch(...)
	{
		cout << "Exception throwed..." << endl;
	}


	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CTimer

void CTimer::Start()
{
	cout << "Start..." << endl;
	QueryPerformanceCounter(&m_liStart);
}

void CTimer::Stop()
{
	LARGE_INTEGER liEnd;
	LARGE_INTEGER liFreq;

	QueryPerformanceCounter(&liEnd);
	QueryPerformanceFrequency(&liFreq);

	//     LowPart  ,
	//   QuadPart.
	//  liFreq   LowPart ,    QuadPart.
	cout << "Stop.\nTest took "
		 << (double)(liEnd.QuadPart - m_liStart.QuadPart) / (double)liFreq.QuadPart
		 << " seconds.\n" << endl;
}

/////////////////////////////////////////////////////////////////////////////
//

const int c_iCount = 1000000000;

int CTest1::GetInt()
{
	return m_i;
}

void CTest1::Inc()
{
	m_i = m_i + 1;
}

void CTest1::Add(int i)
{
	m_i += i;
}

void CTest1::Test(int i, double d, short sh, LPTSTR sz)
{
	i, d, sh, sz;
}

void CTest1::TestVirtual(int i, double d, short sh, LPTSTR sz)
{
	i, d, sh, sz;
}

void CTest2::TestVirtual(int i, double d, short sh, LPTSTR sz)
{
	i, d, sh, sz;
}

/////////////////////////////////////////////////////////////////////////////
//

template <class _SType>
void BubbleSort(_SType *item, int left, int right)
{
	int i, j;
	_SType x;

	for (i = left + 1; i <= right; i++)
	{
		for (j = right; j >= i; j--)
		{
			if (item[j - 1] > item[j])
			{
				x  = item[j];
				item[j] = item[j - 1];
				item[j - 1] = x;
			}
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
//

template <class _SType>
void QuickSort(_SType *item, int left, int right)
{
	int i, j;
	_SType center;
	_SType x;

	i = left;
	j = right;
	center = item[(left + right) / 2];

	while (i <= j)
	{
		while (item[i] < center && i < right)
			i++;
		while (item[j] > center && j > left)
			j--;

		if (i<=j)
		{
			x  = item[i];
			item[i] = item[j];
			item[j] = x;
			i++;
			j--;
		}
	}
	if (left < j)
		QuickSort(item, left, j);
	if (right > i)
		QuickSort(item, i, right);
}

/////////////////////////////////////////////////////////////////////////////
//

void AddNode(CBase * pRoot, const CBase * pNew)
{
	if (pNew->m_i > pRoot->m_i)
	{
		if (pRoot->m_pGreat)
			AddNode(pRoot->m_pGreat, pNew);
		else
			pRoot->m_pGreat = (CBase *)pNew;
	}
	else if (pNew->m_i < pRoot->m_i)
	{
		if (pRoot->m_pLess)
			AddNode(pRoot->m_pLess, pNew);
		else
			pRoot->m_pLess = (CBase *)pNew;
	}
	else
	{
		if (pRoot->m_pEqual)
			AddNode(pRoot->m_pEqual, pNew);
		else
			pRoot->m_pEqual = (CBase *)pNew;
	}
}

void TreeSort(int *item, int left, int right)
{
	CTestEqualZero Root(0);
	CBase * pNewNode = NULL;

	for (int i = left; i <= right; i++)
	{
		const int iCurrItem = item[i];

		if (iCurrItem < 0)
			pNewNode = new CTestLessZero(iCurrItem);
		else if (iCurrItem == 0)
			pNewNode = new CTestEqualZero(iCurrItem);
		else
			pNewNode = new CTestGreatZero(iCurrItem);
		AddNode(&Root, pNewNode);
	}
}

void SortTest(char* szFileName, SORT_TYPE SortType, const int ciByts, int iIterationsCnt)
{
	const int ciElemCnt = ciByts / sizeof(int);
	HANDLE hInputFile = CreateFile(szFileName, GENERIC_READ, FILE_SHARE_READ
		, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);

	if (hInputFile == INVALID_HANDLE_VALUE)
	{
		cerr << "Cannot open " << szFileName << " file!" << endl;
		return;
	}

	int * iAryData = new int[ciElemCnt];
	int * iAryWork = new int[ciElemCnt];
	DWORD dwNumberOfBytesRead = 0;

	cout << "Readin from " << szFileName << "..." << endl;
	ReadFile(hInputFile, iAryData, ciByts, &dwNumberOfBytesRead, NULL);
	if ((int)dwNumberOfBytesRead == ciByts)
	{
		cout << "Read " << ciByts << " bytes" << endl;

		memcpy(iAryWork, iAryData, ciByts);
		int i;

		g_timer.Start();
		switch (SortType)
		{
		case stQuickSort:
			for (i = 0; i < iIterationsCnt; i++)
			{
				if (i > 0)
					memcpy(iAryWork, iAryData, ciByts);
				QuickSort(iAryWork, 0, ciElemCnt - 1);
			}
			break;

		case stBubbleSort:
			for (i = 0; i < iIterationsCnt; i++)
			{
				if (i > 0)
					memcpy(iAryWork, iAryData, ciByts);
				BubbleSort(iAryWork, 0, ciElemCnt - 1);
			}
			break;

		case stTreeSort:
			for (i = 0; i < iIterationsCnt; i++)
			{
				if (i > 0)
					memcpy(iAryWork, iAryData, ciByts);
				TreeSort(iAryWork, 0, ciElemCnt - 1);
			}
			break;
		}
		g_timer.Stop();
	}
	else
		cerr << "Cannot read " << ciByts << "bytes from "
		     << szFileName << " file!" << endl;

	CloseHandle(hInputFile);
	delete[] iAryData;
	delete[] iAryWork;
}

/////////////////////////////////////////////////////////////////////////////
//

char * g_szTestDataFileName = "..\\..\\q3.zip";

void PerformeQuickSortTest()
{
	cout << "Quick Sort Test" << endl;
	SortTest(g_szTestDataFileName, stQuickSort, 100000000, 1);
}

void PerformeBubbleSortTest()
{
	cout << "Bubble Sort Test" << endl;
	SortTest(g_szTestDataFileName, stBubbleSort, 150000, 1);
}

void PerformeTreeTest()
{
	cout << "Tree Test" << endl;
	SortTest(g_szTestDataFileName, stTreeSort, 10000000, 1);
}

/////////////////////////////////////////////////////////////////////////////
// MemberAccessTest

void PerformMemberAccessTest()
{
	CTest1 test1;

	cout << "Member Access Test" << endl;
	g_timer.Start();
	for(int i = 0; i < c_iCount; i++)
		test1.Inc();
	g_timer.Stop();
}

/////////////////////////////////////////////////////////////////////////////
// MethodCallTest

void PerformMethodCallTest()
{
	MethodCallTest(c_iCount);
}

void MethodCallTest(int iInitVal)
{
	CTest1 test1;

	cout << "Method Call Test" << endl;
	g_timer.Start();
	for(int i = 0; i < iInitVal; i++)
		test1.Test(i, 3.123, 1, "Some string");
	g_timer.Stop();
}

/////////////////////////////////////////////////////////////////////////////
// VirtualMehodCallTest

void PerformVirtualMehodCallTest()
{
	cout << "Virtual Method Call Test" << endl;
	VirtualMehodCallTest(c_iCount);
}

void VirtualMehodCallTest(int iInitVal)
{
	CTest2 test2;
	CTest1& rTest1 = test2;

	g_timer.Start();
	for(int i = 0; i < iInitVal; i++)
		rTest1.TestVirtual(i, 3.123, 1, "Some string");
	g_timer.Stop();
}

/////////////////////////////////////////////////////////////////////////////
// PiTest

void __cdecl xtoa
		( unsigned long val
		, char *buf
		, unsigned radix
		, int is_neg
		)
{
		char *p;				/* pointer to traverse string */
		char *firstdig; 		/* pointer to first digit */
		char temp;				/* temp char */
		unsigned digval;		/* value of digit */

		p = buf;

		if (is_neg) {
			/* negative, so output '-' and negate */
			*p++ = '-';
			val = (unsigned long)(-(long)val);
		}

		firstdig = p;			/* save pointer to first digit */

		do {
			digval = (unsigned) (val % radix);
			val /= radix;		/* get next digit */

			/* convert to ascii and store */
			if (digval > 9)
				*p++ = (char) (digval - 10 + 'a');	/* a letter */
			else
				*p++ = (char) (digval + '0');		/* a digit */
		} while (val > 0);

		/* We now have the digit of the number in the buffer, but in reverse
		   order.  Thus we reverse them now. */

		*p-- = '\0';			/* terminate string; p points to last digit */

		do {
			temp = *p;
			*p = *firstdig;
			*firstdig = temp;	/* swap *p and *firstdig */
			--p;
			++firstdig; 		/* advance to next two digits */
		} while (firstdig < p); /* repeat until halfway */
}

char* __cdecl itoa
		( int val
		, char *buf
		, int radix
		)
{
		if (radix == 10 && val < 0)
			xtoa((unsigned long)val, buf, radix, 1);
		else
			xtoa((unsigned long)(unsigned int)val, buf, radix, 0);
		return buf;
}

void PerformPiTest()
{
	const int nDigits = 15000;
	char* szPi = (char*)alloca(nDigits + 1);

	cout << "PI Computation Test" << endl;
	g_timer.Start();
	if (PiTest(szPi, nDigits))
	{
		g_timer.Stop();
		cout << "The " << nDigits << " of Pi is\n"
			 << szPi << endl;
	}
}

bool PiTest(char* szPi, const int nDigits)
{
	if (nDigits > 54900)
	{
		cerr << "Error in PiTest(): n must be <= 54900" << endl;
		return false;
	}

	char* szCurDigit = szPi;
	int d = 0, e, b, g, r;
	int c = (nDigits / 4 + 1) * 14;
	int* a = (int*)alloca(c * sizeof(int));
	int f = 10000;

	for (int i = 0; i < c; i++)
		a[i] = 20000000;

	while ((b = c -= 14) > 0)
	{
		d = e = d % f;

		while (--b > 0)
		{
			d = d * b + a[b];
			g = (b << 1) - 1;
			a[b] = (d % g) * f;
			d /= g;
		}

		r = e + d / f;

		if (r < 1000)
		{
			if (r > 99)
			{
				*szCurDigit = '0';
				szCurDigit++;
			}
			else if (r > 9)
			{
				*szCurDigit = '0';
				szCurDigit++;
				*szCurDigit = '0';
				szCurDigit++;
			}
			else
			{
				*szCurDigit = '0';
				szCurDigit++;
				*szCurDigit = '0';
				szCurDigit++;
				*szCurDigit = '0';
				szCurDigit++;
			}
			//pi.Append(zero[r > 99 ? 0 : r > 9 ? 1 : 2]);
		}
		std::itoa(r, szCurDigit, 10);
		szCurDigit = szCurDigit + strlen(szCurDigit);
		//pi.Append(r);
	}
	*szCurDigit = 0;
	return true;
}

/////////////////////////////////////////////////////////////////////////////
// StringTest

void PerformStringTest()
{
	string ss;

	cout << "String Concatenation Test" << endl;
	g_timer.Start();
	for (int i = 0; i < 10000000; i++)
	{
		ss = ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>";
		ss += " ";
		ss += " ";
		ss += "";
		ss += '\n';
	}
	g_timer.Stop();
}

/////////////////////////////////////////////////////////////////////////////
// FloatTest

void PerformFloatTest()
{
	cout << "Floating-point Test" << endl;
	FloatTest(1000000000);
}

void FloatTest(int iInitVal)
{
	g_timer.Start();
	double f0 = 0;
	double f1 = 123.456789;
	double f2 = 98765.12345678998765432;
	double f3 = 12345678943.98;

	for (int i = 1; i < iInitVal; i++)
	{
		f0 = (f1	/ (double)i) - f2 + (f3 * (double)i);
	}
	g_timer.Stop();

	//cout << "Result is " << f0 << endl;
	printf("Result is %f\n", f0);
}

void PerformAtrTest()
{
	cout << "Floating-point Test 2" << endl;
	//try
	{
		AtrTest(50000000);
	}
	//catch(...)
	{
	}
}

void AtrTest(int iInitVal)
{

	g_timer.Start();
	//  .
	double x1 = -1, y1 = -1, z1 = 0;
	double x2 = -1, y2 =  1, z2 = 0;
	double x3 =  1, y3 = -1, z3 = 0;
	double x4 =  1, y4 =  1, z4 = 0;
	//  
	double px1 = 0, py1 = 0, pz1 = 0;
	double px2 = 0, py2 = 0, pz2 = 0;
	double px3 = 0, py3 = 0, pz3 = 0;
	double px4 = 0, py4 = 0, pz4 = 0;

	double ansx = 0;
	double ansy = 0;
	double ansz = 0;

	// double anssumx = 0;
	// double anssumy = 0;
	// double anssumz = 0;

	long iOptnum = iInitVal;// ,     
	double t = 0;
	double dt = 1.0 / iOptnum; //   t   
	double n0 = 0 , n1 = 0, n2 = 0, n3 = 0; // . 

	for (long i = 0; i < iOptnum; i++) 
	{
		
		n0 = ( -t * (( 1 - t) * (1 - t))) / 2;
		n1 = ( 2 -5 * t * t + 3 * t * t * t) / 2;
		n2 = ( t / 2) * (1 + 4 * t - 3 * t * t);
		n3 = -(( t * t) / 2) * (1 - t);
		

		px1 = x1 * n0;
		py1 = y1	* n0;
		pz1 = z1	* n0;

		px2 = x2 * n1;
		py2 = y2	* n1;
		pz2 = z2	* n1;


		px3 = x3 * n2;
		py3 = y3	* n2;
		pz3 = z3	* n2;

		px4 = x4 * n3;
		py4 = y4	* n3;
		pz4 = z4	* n3;

		ansx = px1 + px2 + px3 + px4; 
		ansy = py1 + py2 + py3 + py4; 
		ansz = pz1 + pz2 + pz3 + pz4; 
		
	//	anssumx += ansx;
	//	anssumy += ansy;
	//	anssumz += ansz;
		t += dt;
	}
	g_timer.Stop();
}



void _assert() {}
