//
//	File:    test.cpp
//	Date:    12/2/2001
//
//	Description:
//		NONE
//
//	Update History:
//		NONE
//
//	Lase Modification:
//		$Author$:$Date$
//
/////////////////////////////////////////////////////////////////////////////

#ifndef __TEST_H__
#define __TEST_H__

/////////////////////////////////////////////////////////////////////////////
//
char* __cdecl itoa( int val, char *buf, int radix);

class CTimer
{
public:
	void Start();
	void Stop();

protected:
	LARGE_INTEGER m_liStart;
};

extern CTimer g_timer;

/////////////////////////////////////////////////////////////////////////////
//

class CTest1
{
public:
	CTest1() : m_i(0) { }

	int m_i;
	int GetInt();
	void Inc();
	void Test(int i, double d, short sh, LPTSTR sz);
	virtual void TestVirtual(int i, double d, short sh, LPTSTR sz);
	void Add(int i);
};

class CTest2 : public CTest1
{
public:
	virtual void TestVirtual(int i, double d, short sh, LPTSTR sz);
};

/////////////////////////////////////////////////////////////////////////////
//

#if defined USE_ATL_ALLOCATOR
#define DECLARE_USE_STL_ALLOCATOR(type)\
	public:\
		void* operator new(size_t n)  { return __STD::alloc::allocate(sizeof(type)); }\
		void operator delete(void* p) { __STD::alloc::deallocate(p, sizeof(type)); }
#else
#define DECLARE_USE_STL_ALLOCATOR(type)
#endif

enum SORT_TYPE
{
	stQuickSort,
	stBubbleSort,
	stTreeSort
};

class CBase
{
	DECLARE_USE_STL_ALLOCATOR(CBase)

public:
	CBase(const int i) : m_pGreat(NULL), m_pLess(NULL), m_pEqual(NULL), m_i(i) { }
	~CBase()
	{
		delete m_pGreat;
		delete m_pLess;
		delete m_pEqual;
	}
	int m_i;
	CBase * m_pGreat;
	CBase * m_pLess;
	CBase * m_pEqual;
};

class CTestGreatZero : public CBase
{
	DECLARE_USE_STL_ALLOCATOR(CTestGreatZero)

public:
	CTestGreatZero(const int i) : CBase(i), m_i1(0), m_i2(0), m_i3(0) { }

protected:
	int m_i1;
	int m_i2;
	int m_i3;
};

class CTestLessZero : public CTestGreatZero
{
	DECLARE_USE_STL_ALLOCATOR(CTestLessZero)

public:
	CTestLessZero(const int i) : CTestGreatZero(i), m_i4(0), m_i5(0) { }
	int m_i4;
	int m_i5;
};

class CTestEqualZero : public CTestLessZero
{
	DECLARE_USE_STL_ALLOCATOR(CTestLessZero)

public:
	CTestEqualZero(const int i) : CTestLessZero(i), m_i6(0), m_d(0) { }

private:
	int m_i6;
	double m_d;
};

/////////////////////////////////////////////////////////////////////////////
//

void PerformMemberAccessTest();

void PerformMethodCallTest();
void MethodCallTest(int iInitVal);

void PerformVirtualMehodCallTest();
void VirtualMehodCallTest(int iInitVal);

void PerformeQuickSortTest();
void PerformeBubbleSortTest();
void PerformeTreeTest();

void PerformPiTest();
bool PiTest(char* szPi, const int nDigits);

void PerformStringTest();

void PerformFloatTest();
void FloatTest(int iInitVal);

void PerformAtrTest();
void AtrTest(int iInitVal);

/////////////////////////////////////////////////////////////////////////////

#endif	// #ifndef __TEST_H__
